SystemOrganization addCategory: #'Ma files additions-Info'!

PackageInfo subclass: #MaFilesAdditionsPackagInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ma files additions-Info'!

!MaFilesAdditionsPackagInfo class methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 16:23'!
packageName
	^ 'Ma files additions'! !

!MaFilesAdditionsPackagInfo methodsFor: 'as yet unclassified' stamp: 'cmm 3/20/2009 17:40'!
prerequisitePackageNames
	^ super prerequisitePackageNames , {  (MaStatisticsPackageInfo packageName)  }! !

!DirectoryEntry methodsFor: '*ma files additions' stamp: 'cmm 2/12/2009 18:56'!
directoryName
	"Answer the directory to shell to for this item."
	self subclassResponsibility ! !

!DirectoryEntry methodsFor: '*ma files additions' stamp: 'cmm 9/20/2007 17:05'!
maTotalFileSizeString
	"Answer my file size as an easy-to-read String."
	^ self totalFileSize maAsBytesDescription! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:24'!
addToDirectoryCount: anInteger 
	self directoryCountStat addValue: anInteger! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:24'!
addToFileCount: anInteger 
	self fileCountStat addValue: anInteger! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:19'!
addToTotalSize: anInteger 
	self fileSizeStat addValue: anInteger! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:54'!
contributeStatisticsTo: aDirectoryEntryDirectory 
	"Add my size information to the cumulative total in aDirectoryEntryDirectory."
	self initializeStatistics.
	aDirectoryEntryDirectory
		addToTotalSize: self totalFileSize ;
		addToDirectoryCount: self directoryCount ;
		addToFileCount: self fileCount! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 9/19/2007 15:41'!
directoryCount
	"Answer the total number of directory entries in my directory, including all subdirectories."
	^ self directoryCountStat sum! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 9/28/2007 12:33'!
directoryCountStat
	"Statistics about the number of directories per folder."
	^ self 
		attributeNamed: #directoryCountStat
		ifAbsent: 
			[ self
				initializeStatistics ;
				directoryCountStat ]! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:22'!
directoryCountStat: aMaStat 
	self 
		attributeNamed: #directoryCountStat
		put: aMaStat! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 2/12/2009 18:56'!
directoryName
	"Answer the directory to shell to for this item."
	^ self asFileDirectory pathName! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 9/19/2007 15:41'!
fileCount
	"Answer the total number of file entries in my directory, including all subdirectories."
	^ self fileCountStat sum! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 9/28/2007 12:32'!
fileCountStat
	"Statistics about the number of files per folder."
	^ self 
		attributeNamed: #fileCountStat
		ifAbsent: 
			[ self
				initializeStatistics ;
				fileCountStat ]! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:21'!
fileCountStat: aMaStat 
	self 
		attributeNamed: #fileCountStat
		put: aMaStat! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 9/13/2007 17:19'!
fileSizeStat
	^ self 
		attributeNamed: #fileSizeStat
		ifAbsent: 
			[ self
				initializeStatistics ;
				fileSizeStat ]! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:19'!
fileSizeStat: aMaStat 
	self 
		attributeNamed: #fileSizeStat
		put: aMaStat! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:48'!
incrementDirectoryOrFileCount: twoElementArray 
	twoElementArray 
		at: 1
		put: (twoElementArray at: 1) + 1! !

!DirectoryEntryDirectory methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:51'!
initializeStatistics
	"Enumerate my entire directory tree to gather my statistics."
	| directoryAndFileCount |
	self
		fileSizeStat: MaStat new ;
		fileCountStat: MaStat new ;
		directoryCountStat: MaStat new.
	directoryAndFileCount _ {  0. 0  }.
	self asFileDirectory entries in: 
		[ : myEntries | 
		myEntries
			do: [ : eachEntry | eachEntry contributeStatisticsTo: self ] ;
			do: [ : eachEntry | eachEntry incrementDirectoryOrFileCount: directoryAndFileCount ] ].
	self
		addToDirectoryCount: (directoryAndFileCount at: 1) ;
		addToFileCount: (directoryAndFileCount at: 2)! !

!DirectoryEntryDirectory methodsFor: '*ma files additions' stamp: 'cmm 9/13/2007 17:19'!
totalFileSize
	"Answer the cumulative size of all files and folders in the directories I contain, including their totalFileSize."
	^ self fileSizeStat sum ifNil: [ 0 ]! !

!DirectoryEntryFile methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:54'!
contributeStatisticsTo: aDirectoryEntryDirectory 
	"Add my size information to the cumulative total in aDirectoryEntryDirectory."
	aDirectoryEntryDirectory addToTotalSize: self fileSize! !

!DirectoryEntryFile methodsFor: '*ma files additions' stamp: 'cmm 2/12/2009 18:44'!
directoryName
	"Answer the directory to shell to for this item."
	^ self containingDirectory pathName! !

!DirectoryEntryFile methodsFor: '*ma files additions-private' stamp: 'cmm 9/13/2007 17:49'!
incrementDirectoryOrFileCount: twoElementArray 
	twoElementArray 
		at: 2
		put: (twoElementArray at: 2) + 1! !

!DirectoryEntryFile methodsFor: '*ma files additions' stamp: 'cmm 9/20/2007 17:07'!
totalFileSize
	"API compatible with DirectoryEntryDirectory>>#totalFileSize, but just answers my fileSize."
	^ self fileSize! !

!FileDirectory class methodsFor: '*ma files additions' stamp: 'cmm 4/21/2009 22:12'!
maDirectoryEntryFor: fullyQualifiedFilename 
	"Given fullyQualifiedFilename, answer a DirectoryEntryFile if fullyQualifiedFilename is a file, or a DirectoryEntryDirectory if it refers to a directory."
	^ (FileDirectory on: fullyQualifiedFilename) in: [ : fd | fd containingDirectory entryAt: fd localName ]! !

!FileDirectory methodsFor: '*ma files additions' stamp: 'cmm 3/21/2009 21:45'!
archiveFilesMatching: aBlock toZipFileNamed: zipFilename 
	| archive filesArchived |
	filesArchived := OrderedCollection new.
	archive := ZipArchive new.
	
	[ 'Archiving...' 
		displayProgressAt: Display center
		from: 0
		to: self entries size
		during: 
			[ : bar | 
			self entries withIndexDo: 
				[ : each : x | 
				bar value: x.
				(each isDirectory not and: [ aBlock value: each ]) ifTrue: 
					[ archive 
						addFile: each fullName
						as: each name.
					filesArchived add: each ] ] ].
	archive writeToFileNamed: (self fullNameFor: ((zipFilename 
				maEndsWith: '.zip'
				caseSensitive: false) 
				ifTrue: [ zipFilename ]
				ifFalse: [ zipFilename , '.zip' ])) ] ensure: [ archive close ].
	self halt.
	filesArchived do: [ : each | each delete ]! !

!FileDirectory methodsFor: '*ma files additions' stamp: 'cmm 3/21/2009 21:21'!
archiveFilesOlderThan: aDuration 
	| cutoff |
	self halt.
	cutoff := DateAndTime now - aDuration.
	self 
		archiveFilesMatching: [ : each | each modificationDateAndTime < cutoff ]
		toZipFileNamed: 'prior_to_' , cutoff asString , '.zip'! !

!FileDirectory methodsFor: '*ma files additions' stamp: 'cmm 2/20/2009 16:02'!
asFileDirectory
	^ self! !

!FileDirectory methodsFor: '*ma files additions' stamp: 'cmm 2/18/2009 15:03'!
directoryName
	"Answer the directory to shell to for this item."
	^self pathName! !
